routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('auth.login');
    // return view('welcome');
    // return view('admin.auth.login');
    // return view('auth.login');
});


Route::get('login', 'AuthStaff\LoginController@showLoginForm')->name('login');
Route::post('login', 'AuthStaff\LoginController@login');
Route::post('logout', 'AuthStaff\LoginController@logout')->name('logout');


Route::get('register', 'AuthStaff\RegisterController@showRegistrationForm')->name('register');
Route::post('register', 'AuthStaff\RegisterController@register');
Route::get('email/verify', 'AuthStaff\VerificationController@show')->name('verification.notice');
Route::get('email/verify/{id}', 'AuthStaff\VerificationController@verify')->name('verification.verify');
Route::get('email/resend', 'AuthStaff\VerificationController@resend')->name('verification.resend');

Route::name('staff.')->group(function () {
	Route::group(['middleware' => ['staff', 'auth:staff']], function () {
		Route::get('home', 'AuthStaff\HomeController@index')->name('home');

		Route::middleware(['verified'])->group(function () {
			Route::get('archive', 'AuthStaff\ArchiveController@index')->name('archive.index');
			Route::get('archive/data', 'AuthStaff\ArchiveController@data')->name('archive.data');
			Route::get('archive/{id}', 'AuthStaff\ArchiveController@show')->name('archive.show');
			Route::get('archive/download/{id}', 'AuthStaff\ArchiveController@download')->name('archive.download');
		});

	});
});

// Auth::routes();

Route::prefix('admin')->group(function () {

	Route::name('admin.')->group(function () {

		Route::get('login', 'Auth\LoginController@showLoginForm')->name('login');
		Route::post('login', 'Auth\LoginController@login');

		Route::group(['middleware' => ['auth']], function () {


			Route::post('logout', 'Auth\LoginController@logout')->name('logout');

			Route::get('home', 'HomeController@index')->name('home');

			Route::post('incoming/upload/{id}', 'Admin\IncomingMailController@upload')->name('incoming.upload');
			Route::get('incoming/view/{id}', 'Admin\IncomingMailController@viewFile')->name('incoming.view');
			Route::post('incoming/download', 'Admin\IncomingMailController@download')->name('incoming.download');
			Route::get('incoming/print/{id}', 'Admin\IncomingMailController@print')->name('incoming.print');
			Route::get('incoming/data', 'Admin\IncomingMailController@data')->name('incoming.data');
			Route::resource('incoming', 'Admin\IncomingMailController');

			// Route::post('outgoing/upload/{id}', 'Admin\OutgoingMailController@upload')->name('outgoing.upload');
			// Route::get('outgoing/view/{id}', 'Admin\OutgoingMailController@viewFile')->name('outgoing.view');
			// Route::post('outgoing/download', 'Admin\OutgoingMailController@download')->name('outgoing.download');
			// Route::get('outgoing/print/{id}', 'Admin\OutgoingMailController@print')->name('outgoing.print');
			// Route::get('outgoing/data', 'Admin\OutgoingMailController@data')->name('outgoing.data');
			// Route::resource('outgoing', 'Admin\OutgoingMailController');

			// Route::get('archive/download/{id}', 'Admin\ArchiveController@download')->name('archive.download');
			// Route::get('archive/data', 'Admin\ArchiveController@data')->name('archive.data');
			// Route::resource('archive', 'Admin\ArchiveController');
      Route::get('profile', 'Admin\ProfileController@index')->name('profile.index');
      Route::post('profile/update', 'Admin\ProfileController@update')->name('profile.update');
      Route::post('profile/updatePass', 'Admin\ProfileController@updatePass')->name('profile.pass');

      Route::group(['middleware' => ['checkRole']], function () {

  			Route::get('category/data', 'Admin\CategoryController@data')->name('category.data');
  			Route::resource('category', 'Admin\CategoryController');

  			Route::post('staff/deleteAll', 'Admin\StaffController@postDeleteAll')->name('staff.delete.all');
  			Route::get('staff/data', 'Admin\StaffController@data')->name('staff.data');
  			Route::resource('staff', 'Admin\StaffController');

  			Route::post('user/deleteAll', 'Admin\AdminController@postDeleteAll')->name('user.delete.all');
  			Route::get('user/data', 'Admin\AdminController@data')->name('user.data');
  			Route::resource('user', 'Admin\AdminController');

      });

		});

	});

});

app/Http/Controllers/Admin/ArchiveController.php
<?php

namespace App\Http\Controllers\Admin;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Kris\LaravelFormBuilder\FormBuilder;
use App\Models\Archive;
use App\Models\Category;
use DataTables;
use Form;
use File;

class ArchiveController extends Controller
{
    private $folder = 'admin.archive';
    private $uri = 'admin.archive';
    private $title = 'Archive';
    private $desc = 'Description';

    public function __construct(Archive $table)
    {
    	$this->table = $table;
    }

    public function index(Request $request)
    {
        $data['title'] = $this->title;
        $data['ajax'] = route($this->uri.'.data');
        $data['create'] = route($this->uri.'.create');
        return view($this->folder.'.index',$data);
    }

    public function data(Request $request)
    {
        if ($request->ajax()) {
            $data = $this->table->select(['id', 'category_id', 'title', 'content', 'created_at']);
            return DataTables::of($data)
                ->editColumn('category_id', function ($index) {
                    return ($index->category->name) ?? '-';
                })
                // ->editColumn('content', function ($index) {
                //     return str_limit($index->content, 10);
                // })
                ->addColumn('action', function ($index) {
                    $tag = Form::open(array("url" => route($this->uri.'.destroy',$index->id), "method" => "DELETE"));
                    $tag .= "<a href=".route($this->uri.'.edit',$index->id)." class='btn btn-primary btn-xs'><i class='fa fa-pencil'></i> Edit</a>";
                    $tag .= " <a href=".route($this->uri.'.show',$index->id)." class='btn btn-success btn-xs'><i class='fa fa-info'></i> Show</a>";
                    $tag .= " <button type='submit' class='delete btn btn-danger btn-xs'><i class='fa fa-trash'></i> Delete</button>";
                    $tag .= Form::close();
                    return $tag;
                })
                ->rawColumns(['id', 'action'])
                ->make(true);
        }
    }

    public function create(FormBuilder $formBuilder)
    {
        $data['title'] = $this->title;
        $data['form'] = $formBuilder->create('App\Forms\ArchiveForm', [
            'method' => 'POST',
            'url' => route($this->uri.'.store')
        ]);
        $data['url'] = route($this->uri.'.index');
        return view($this->folder.'.create', $data);
    }

    public function edit(FormBuilder $formBuilder, $id)
    {
        $data['title'] = $this->title;
        $tbl = $this->table->find($id);
        $data['form'] = $formBuilder->create('App\Forms\ArchiveForm', [
            'method' => 'PUT',
            'model' => $tbl,
            'url' => route($this->uri.'.update', $id)
        ])
        ->modify('files', 'static', [
        // ->addAfter('attachment', 'bayar', 'static', [
            'template' => 'admin.archive.edit_file',
            'value' => function ($val) use ($tbl) {
                return $tbl;
            }
            // 'value' => function ($val) {
            //     return $val;
            // }
            // 'value' => $this->getFieldValues()
            // 'value' => function ($val) {
            //     // $tp = TopUp::find($id);
            //     return $val->topup_date;
            //     // return '<img id="blah" src="'.asset('topupattachment/'.$val).'" alt="" width="200" />';
            // }
            //     return !empty($val) ? ;
            // }
        ]);

        $data['url'] = route($this->uri.'.index');
        return view($this->folder.'.create', $data);
    }

    public function show(FormBuilder $formBuilder, $id)
    {
        $data['title'] = $this->title;
        $tbl = $this->table->find($id);
        $data['form'] = $formBuilder->create('App\Forms\ArchiveForm', [
            'method' => 'PUT',
            'model' => $tbl,
            'url' => route($this->uri.'.update', $id)
        ])
        ->modify('category_id', 'select', [
            'attr' => [
                'disabled' => '',
            ]
        ])
        ->modify('title', 'text', [
            'attr' => [
                'disabled' => '',
            ]
        ])
        ->modify('content', 'textarea', [
            'attr' => [
                'disabled' => '',
            ]
        ])
        ->modify('files', 'static', [
        // ->addAfter('attachment', 'bayar', 'static', [
            'template' => 'admin.archive.show_file',
            'value' => function ($val) use ($tbl) {
                return $tbl;
            }
            // 'value' => $this->getFieldValues()
            // 'value' => function ($val) {
            //     // $tp = TopUp::find($id);
            //     return $val->topup_date;
            //     // return '<img id="blah" src="'.asset('topupattachment/'.$val).'" alt="" width="200" />';
            // }
            //     return !empty($val) ? ;
            // }
        ]);

        $data['url'] = route($this->uri.'.index');
        return view($this->folder.'.show', $data);
    }

    public function store(Request $request)
    {
        $this->table->create($request->all());
        return redirect(route($this->uri.'.index'))->with('success',trans('message.create'));
    }

    public function update(Request $request, $id)
    {
        $this->table->findOrFail($id)->update($request->all());
        return redirect(route($this->uri.'.index'))->with('success', trans('message.update'));
    }
    
    public function destroy($id)
    {
        $tb = $this->table->findOrFail($id);
        $tb->delete();
        return response()->json(['msg' => true,'success' => trans('message.delete')]);
    }

    public function download($id)
    {
        $item = Archive::find($id);
        if (!empty($item->files)) {
            if(File::exists($item->files)) {
                return response()->file($item->files);
            }
        }
        return 'File does not exist';
    }
}

app/Http/Controllers/Admin/StaffController.php
<?php

namespace App\Http\Controllers\Admin;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Kris\LaravelFormBuilder\FormBuilder;
use App\Models\Staff;
use DataTables;
use Form;

class StaffController extends Controller
{
    private $folder = 'admin.staff';
    private $uri = 'admin.staff';
    private $title = 'Staff';
    private $desc = 'Description';

    public function __construct(Staff $table)
    {
    	$this->table = $table;
    }

    public function index(Request $request)
    {
        $data['title'] = $this->title;
        $data['ajax'] = route($this->uri.'.data');
        $data['create'] = route($this->uri.'.create');
        $data['action'] = route($this->uri.'.delete.all');
        return view($this->folder.'.index',$data);
    }

    public function data(Request $request)
    {
        if ($request->ajax()) {
            $data = $this->table->select(['id', 'name', 'email', 'phone', 'status', 'created_at']);
            return DataTables::of($data)
                ->editColumn('id','<input type="checkbox" class="checkbox" name="id[]" value="{{$id}}"/>')
                ->addColumn('status', function ($index) {
                    return ($index->status) ? '<div class="label label-success">ACTIVE</div>' : '<div class="label label-danger">NOT ACTIVE</div>';
                })
                ->addColumn('action', function ($index) {
                    $tag = Form::open(array("url" => route($this->uri.'.destroy',$index->id), "method" => "DELETE"));
                    $tag .= "<a href=".route($this->uri.'.edit',$index->id)." class='btn btn-primary btn-xs'><i class='fa fa-pencil'></i> Edit</a>";
                    // $tag .= " <a href=".route($this->uri.'.show',$index->id)." class='btn btn-success btn-xs'>Show</a>";
                    $tag .= " <button type='submit' class='delete btn btn-danger btn-xs'><i class='fa fa-trash'></i> Delete</button>";
                    $tag .= Form::close();
                    return $tag;
                })
                ->rawColumns(['id', 'status', 'action'])
                ->make(true);
        }
    }

    public function create(FormBuilder $formBuilder)
    {
        $data['title'] = $this->title;
        $data['form'] = $formBuilder->create('App\Forms\StaffForm', [
            'method' => 'POST',
            'url' => route($this->uri.'.store')
        ]);
        $data['url'] = route($this->uri.'.index');
        return view($this->folder.'.create', $data);
    }

    public function edit(FormBuilder $formBuilder, $id)
    {
        $data['title'] = $this->title;
        $tbl = $this->table->find($id);
        $data['form'] = $formBuilder->create('App\Forms\StaffForm', [
            'method' => 'PUT',
            'model' => $tbl,
            'url' => route($this->uri.'.update', $id)
        ])
        ->modify('status', 'choice', [
            'selected' => null
        ])
        ->modify('password', 'password', [
            'attr' => [
              'data-validation' => null,
            ],
            'value' => ''
        ]);

        $data['url'] = route($this->uri.'.index');
        return view($this->folder.'.create', $data);
    }

    public function store(Request $request)
    {
    	$request->validate([
            'email' => 'required|string|email|max:255|unique:staff'
    	]);

        $this->table->create($request->all());
        return redirect(route($this->uri.'.index'))->with('success',trans('message.create'));
    }

    public function update(Request $request, $id)
    {
    	$request->validate([
            'email' => 'required|string|email|max:255|unique:staff,email,'.$id
    	]);
    	if(empty($request->password)){
            unset($request['password']);
        }
        $this->table->findOrFail($id)->update($request->all());
        return redirect(route($this->uri.'.index'))->with('success', trans('message.update'));
    }

    public function destroy($id)
    {
        $tb = $this->table->findOrFail($id);
        $tb->delete();
        return response()->json(['msg' => true,'success' => trans('message.delete')]);
    }

    public function postDeleteAll(Request $request)
    {
        $ID = $request->id;
        if(count($ID)>0){
            foreach ($ID as $key => $value) {
                $del = $this->tabel->findOrFail($value);
                $del->delete();
            }
            return redirect(route($this->uri.'.index'))->with('success',trans('message.delete.all'));
        }
    }
}

app/Http/Controllers/AuthStaff/ArchiveController.php
<?php

namespace App\Http\Controllers\AuthStaff;

use Illuminate\Http\Request;
use Illuminate\Support\Str;
use App\Http\Controllers\Controller;
use App\Models\IncomingMail;
use App\Models\Archive;
use App\Models\Category;
use DataTables;
use Form;
use File;
use Carbon\Carbon;

class ArchiveController extends Controller
{
	public $uri = 'staff.archive';

    public function index()
    {
    	// $data['archive'] = Archive::orderBy('category_id')->get();
    	$data['ajax'] = route($this->uri.'.data');
    	return view('staff.archive.index', $data);
    }

    public function data(Request $request)
    {
        if ($request->ajax()) {
            $data = IncomingMail::select(['id', 'type', 'category_id', 'files','disposition', 'letter_entry']);
            return DataTables::of($data)
                ->editColumn('category_id', function ($index) {
                    return ($index->category->name) ?? '-';
                })
                ->editColumn('type', function ($index) {
									if ($index->type == 1) {
										return 'Surat Masuk';
									} elseif ($index->type == 2) {
										return 'Surat Keluar';
									} else {
										return '-';
									}
                })
                ->editColumn('disposition', function ($index) {
                    return Str::words($index->disposition, 2);
                })
                ->editColumn('letter_entry', function ($index) {
                    return Carbon::parse($index->letter_entry)->format('d-m-Y H:i');
                })
                ->addColumn('action', function ($index) {
                    $tag = !empty($index->files) ? "<a href=".route($this->uri.'.download',$index->id)." class='btn btn-success btn-sm'><i class='fa fa-download' aria-hidden='true'></i></a>" : "<a href='#' class='btn btn-success btn-sm disabled'><i class='fa fa-download' aria-hidden='true'></i></a>";
                    $tag .= " <a href=".route($this->uri.'.show',$index->id)." class='btn btn-info btn-sm'><i class='fa fa-info-circle' aria-hidden='true'></i></a>";
                    return $tag;
                })
                ->rawColumns(['id', 'action'])
                ->make(true);
        }
    }

    public function show($id)
    {
    	$data['row'] = IncomingMail::find($id);
    	return view('staff.archive.show', $data);
    }

    public function download($id)
    {
        $item = IncomingMail::find($id);
        if (!empty($item->files)) {
            if(File::exists($item->files)) {
                return response()->download($item->files);
            }
        }
        return 'File does not exist';
    }

}

resources/views/staff/archive/index.blade.php
@extends('layouts.app')

@section('head-script')
    <link rel="stylesheet" type="text/css" href="/themes/app-assets/vendors/css/tables/datatable/datatables.min.css">
    <link rel="stylesheet" type="text/css" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.css">
@endsection

@section('end-script')
    <script src="/themes/app-assets/vendors/js/tables/datatable/datatables.min.js"></script>
    <script type="text/javascript">
        var table;
        $(function() {
            table = $('#data-table').DataTable({
                processing: true,
                serverSide: true,
                ajax: '{{$ajax}}',
                order: [[4,'desc']],
                columns: [
                    { data: 'id', searchable: false, orderable: false},
                    { data: 'type', searchable: false, orderable: false},
                    { data: 'category_id', searchable: false, orderable: false},
                    { data: 'disposition', searchable: false, orderable: false},
                    { data: 'letter_entry', searchable: false, orderable: true},
                    { data: 'action', searchable: false, orderable: false}
                ],
                columnDefs: [{
                  "targets": 0,
                  "searchable": false,
                  "orderable": false,
                  "data": null,
                  // "title": 'No.',
                  "render": function (data, type, full, meta) {
                      return meta.settings._iDisplayStart + meta.row + 1;
                  }
                }],
            });
        });
    </script>
@endsection

@section('content')
<div class="container">
    <div class="row justify-content-center">
        <div class="col-md-8">
            <div class="card">
                <div class="card-header">Archive</div>

                <div class="card-body">
                    @if (session('status'))
                        <div class="alert alert-success" role="alert">
                            {{ session('status') }}
                        </div>
                    @endif

                    <table id="data-table" class="table table-striped">
                        <thead>
                            <tr>
                                <th>#</th>
                                <th>Jenis</th>
                                <th>Kategori</th>
                                <th>Tujuan Disposisi</th>
                                <th>Surat Masuk</th>
                                <th>Action</th>
                            </tr>
                        </thead>
                        <tbody>
                        </tbody>
                    <table>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/staff/archive/show.blade.php
@extends('layouts.app')

@section('head-script')
    <link rel="stylesheet" type="text/css" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.css">
@endsection

@section('content')
<div class="container">
    <div class="row justify-content-center">
        <div class="col-md-8">
            <div class="card">
                <div class="card-header">Archive Detail</div>

                <div class="card-body">

                        <div class="form-group row">
                            <label class="col-md-4 col-form-label text-md-right">{{ __('Jenis') }}</label>

                            <div class="col-md-6">
                                @if($row->type == 1)
                                  <input type="text" class="form-control" disabled="" value="Surat Masuk">
                                @elseif($row->type == 2)
                                  <input type="text" class="form-control" disabled="" value="Surat Keluar">
                                @else
                                  <input type="text" class="form-control" disabled="" value="-">
                                @endif
                            </div>
                        </div>

                        <div class="form-group row">
                            <label class="col-md-4 col-form-label text-md-right">{{ __('Kategori') }}</label>

                            <div class="col-md-6">
                                <input type="text" class="form-control" disabled="" value="{{ $row->category->name }}">
                            </div>
                        </div>

                        <div class="form-group row">
                            <label class="col-md-4 col-form-label text-md-right">{{ __('No Berkas') }}</label>

                            <div class="col-md-6">
                                <input type="text" class="form-control" disabled="" value="{{ $row->code }}">
                            </div>
                        </div>

                        <div class="form-group row">
                            <label class="col-md-4 col-form-label text-md-right">{{ __('No Surat') }}</label>

                            <div class="col-md-6">
                                <input type="text" class="form-control" disabled="" value="{{ $row->mail_number }}">
                            </div>
                        </div>

                        <div class="form-group row">
                            <label class="col-md-4 col-form-label text-md-right">{{ __('Perihal') }}</label>

                            <div class="col-md-6">
                                <input type="text" class="form-control" disabled="" value="{{ $row->subject }}">
                            </div>
                        </div>

                        <div class="form-group row">
                            <label class="col-md-4 col-form-label text-md-right">{{ __('Alamat Penerima') }}</label>

                            <div class="col-md-6">
                                <input type="text" class="form-control" disabled="" value="{{ $row->return_address }}">
                            </div>
                        </div>

                        <div class="form-group row">
                            <label class="col-md-4 col-form-label text-md-right">{{ __('Penerima') }}</label>

                            <div class="col-md-6">
                                <input type="text" class="form-control" disabled="" value="{{ $row->receiver }}">
                            </div>
                        </div>

                        <div class="form-group row">
                            <label class="col-md-4 col-form-label text-md-right">{{ __('Tujuan Disposisi') }}</label>

                            <div class="col-md-6">
                                <input type="text" class="form-control" disabled="" value="{{ $row->disposition }}">
                            </div>
                        </div>

                        <div class="form-group row">
                            <label class="col-md-4 col-form-label text-md-right">{{ __('Tanggal Masuk') }}</label>
                            <div class="col-md-6">
                                <input type="text" class="form-control" disabled="" value="{{ date('d M Y, H:i',strtotime($row->letter_entry)) }}">
                            </div>
                        </div>

                        <div class="form-group row">
                            <label class="col-md-4 col-form-label text-md-right">{{ __('Tanggal Terima') }}</label>
                            <div class="col-md-6">
                                <input type="text" class="form-control" disabled="" value="{{ date('d M Y, H:i',strtotime($row->received_date)) }}">
                            </div>
                        </div>

                        <div class="form-group row">
                            <label class="col-md-4 col-form-label text-md-right">{{ __('File') }}</label>

                            <div class="col-md-6">
                                @if(!empty($row->files))
                                <a href="{{route('staff.archive.download', $row->id)}}" class="btn btn-success btn-sm"><i class='fa fa-download' aria-hidden='true'></i> Download</a>
                                @else
                                <a href="{{route('staff.archive.download', $row->id)}}" class="btn btn-success btn-sm disabled"><i class='fa fa-download' aria-hidden='true'></i> Download</a>
                                @endif
                            </div>
                        </div>

                        <div class="form-group row mb-0">
                            <div class="col-md-6 offset-md-4">
                                <a href="{{route('staff.archive.index')}}" class="btn btn-primary">
                                    {{ __('Back') }}
                                </a>
                            </div>
                        </div>

                </div>
            </div>
        </div>
    </div>
</div>
@endsection